#pragma warning(disable:4503) // "identifier truncated"
#pragma warning(disable:4786) // "debug information truncated"
#pragma warning(disable:4508) // "main should return int" -- bogus warning.
#include <iostream>
#include <sstream>
#include "Indexer.h"
using namespace std;

main() {
    Indexer idx;
    SearchResult s;

    string cmd,word;
    while (cin) {
        cout << "(load,find,or,and,quit)> ";
        cin >> cmd;
        if (cmd=="load") {
            string file;
            cin >> file;
            idx.processLocation(file);
            cout << "Loaded " << file << "\n";
            idx.dumpStats();
            continue;
        } else if (cmd=="find") {
            cin >> word;
            s = idx.queryWord(word);
        } else if (cmd=="or") {
            cin >> word;
            idx.unionResult(s,word);
        } else if (cmd=="and") {
            cin >> word;
            idx.intersectResult(s,word);
        } else if (cmd=="dump") {
            cout << "CONTENTS OF INDEX:\n";
            idx.dump();
            cout << "------------------\n";
            continue;
        } else if (cmd=="clear") {
            idx.clear();
            s.clear();
            continue;
        } else if (cmd=="quit") {
            exit(0);
        } else if (cmd=="") 
            continue;

        cout << "\nResult after " << cmd << " " << word << ":\n";
        printByFrequency(s);
        cout << "-------\n";
    }
}